/*[Parámetros de la mordaza para la maleta]*/

//Diámetro del asa de la maleta
Diametro = 30;      

//Anchura de la mordaza
Ancho = 22;         

//Grosor de las paredes del soporte
Grosor = 8;         

//Diámetro del tornillo que se va a utilizar
Tornillo = 4;       

//Diámetro de la cabeza del tornillo
Cabeza = 6.7;       

//Profundidad de la cabeza del tornillo
Prof_Cabeza = 3;    

//Diámetro de la tuerca hexagonal que se va a utilizar (en su parte más ancha)
Tuerca = 9;         


/*[Parámetros del nuevo asa]*/

//Lado del cubo de encaje
Cubo = 40;          

//Distancia desde el centro del asa hasta el borde de la maleta
Distancia = 30;     

//Diámetro que deseamos para el nuevo asa
Dia_Tubo = 20;      

//Longitud del tubo extensor
Largo_Tubo = 210;   

//Largo del asa por el que se agarrará la maleta
Largo_Tirador = 100;


/*[Parámetros de la palanca de apriete]*/

//Diámetro Exterior del eje de apriete
Dia_Grande = 20;    

//Diámetro Interior del eje de apriete
Dia_Peque = 8;      

//Desplazamiento del Diámeto interior con respecto al exterior
Desplazamiento = 2; 

//Longitud de la palanca de apriete
Largo_Palanca = 50; 

//Grosor de la palanca
Gru_Palanca = 5;    

//Tolerancia entre piezas
Tolerancia = 0.2;   

//Ángulo de rotación de la palanca con respecto al eje
Angulo = -45;        

//Ancho del hueco de la palanca
Hueco = 8;          


/*[Elemento a mostrar]*/

//Elemento que desea mostrar para generar el archivo stl
Mostrar = "Todas";  //[Todas:Todas las partes, Mordaza:Mordaza para el asa de la maleta, Tirador:Tirador de la maleta, Palanca:Palanca de apriete, Pasador:Pasador de la palanca]



/*[hidden]*/
Tubo = Diametro/2;




module Mordaza() {
difference() {
hull() {
    cylinder(Ancho,Tubo+Grosor,Tubo+Grosor,$fn=120,center=true);
        translate([Diametro-Grosor/2,0,0])
        rotate([0,90,90])
            cylinder(Diametro+Grosor*2,Ancho/2,Ancho/2,$fn=120,center=true);
        }
    cylinder(Ancho+1,Tubo,Tubo,$fn=120,center=true);             
    rotate([90,0,0])
    translate([Diametro-Grosor/2+Tornillo/2,0,-Tubo-Grosor])
        cylinder(10,Tuerca/2,Tuerca/2,$fn=6,center=true);
    translate([Diametro,0,0])
        cube([Diametro+Grosor*2,Grosor*2,Ancho+1],center=true);
    translate([Diametro-Grosor/2+Tornillo/2,0,0])
    rotate([0,90,90])
        cylinder(Diametro+Grosor*4+1,Tornillo/2+Tolerancia,Tornillo/2+Tolerancia,$fn=120,center=true);
    translate([Diametro-Grosor/2,-(Diametro+Grosor*2)/2-Grosor/2,-Ancho/2-1]) cylinder(Ancho+2,Dia_Grande/2,Dia_Grande/2,$fn=120);
        }
        }


module Palanca() {
    difference(){
    union(){
    cylinder(Ancho,Dia_Grande/2,Dia_Grande/2,$fn=120);
    rotate([0,0,-Angulo]) translate([Dia_Grande/2-Gru_Palanca,-Largo_Palanca,0]) cube([Gru_Palanca,Largo_Palanca,Ancho]); 
    }
    translate([Desplazamiento,0,-Tolerancia])cylinder(Ancho+2*Tolerancia,Dia_Peque/2,Dia_Peque/2,$fn=120);
    rotate([0,0,-Angulo]) translate([-Dia_Grande,-Largo_Palanca,(Ancho-Hueco-Tolerancia)/2]) cube([Dia_Grande/2-Gru_Palanca+Dia_Grande,2*Largo_Palanca,Hueco+Tolerancia]);
    translate([-Dia_Grande/2,-Dia_Peque/2,(Ancho-Hueco-Tolerancia)/2])cube([Dia_Grande,Dia_Grande,Hueco+Tolerancia]);
}
    
}


module Pasador() {
    difference() {
    cylinder(Ancho,(Dia_Peque-Tolerancia)/2,(Dia_Peque-Tolerancia)/2,$fn=120,center=true);
    rotate([0,90,90]) cylinder(Dia_Peque*2,(Tornillo+Tolerancia)/2,(Tornillo+Tolerancia)/2,$fn=120,center=true);
    translate([0,-Dia_Peque+Prof_Cabeza+Tolerancia*4,0]) rotate([0,90,90]) cylinder(Dia_Peque,(Cabeza+Tolerancia)/2,(Cabeza+Tolerancia)/2,$fn=120,center=true);


    }
}


module Encaje() {
    difference() {
    translate([-Cubo-Distancia+Grosor,-(Diametro+Grosor*2)/2,-Cubo/2]) cube([Cubo+Distancia-Grosor,Diametro+Grosor*2,Cubo]);
    
    translate([-Diametro/2-Distancia,Largo_Tubo/2-Ancho/2,0]) rotate([0,90,90]) cylinder(Largo_Tubo+Ancho,(Dia_Tubo+Tolerancia)/2,(Dia_Tubo+Tolerancia)/2,$fn=120,center=true);
    cylinder(Cubo+1,Tubo,Tubo,$fn=120,center=true);
    translate([-Diametro/2-Distancia,0,0]) cylinder(Cubo+2,(Tornillo+Tolerancia)/2,(Tornillo+Tolerancia)/2,$fn=120,center=true);
    translate([-Diametro/2-Distancia,0,-Cubo/2-1]) cylinder(10,Tuerca/2,Tuerca/2,$fn=6,center=true);
    translate([-Diametro/2-Distancia,0,Cubo/2+(5-Prof_Cabeza)]) cylinder(10,Cabeza/2,Cabeza/2,$fn=120,center=true);
    }
    
}

module Tirador() {
    difference() {
    union() {
    translate([-Diametro/2-Distancia,Largo_Tubo/2-Ancho/2,0]) rotate([0,90,90]) cylinder(Largo_Tubo+Ancho,Dia_Tubo/2,Dia_Tubo/2,$fn=120,center=true);
    translate([-Diametro/2-Distancia,Largo_Tubo-Ancho/2+Dia_Tubo/2,0]) rotate([0,0,90]) cylinder(Largo_Tirador-Dia_Tubo,Dia_Tubo/2,Dia_Tubo/2,$fn=120,center=true);
    translate([-Diametro/2-Distancia,Largo_Tubo-Ancho/2+Dia_Tubo/2,Largo_Tirador/2-Dia_Tubo/2]) sphere(Dia_Tubo/2,$fn=120);
    translate([-Diametro/2-Distancia,Largo_Tubo-Ancho/2+Dia_Tubo/2,-Largo_Tirador/2+Dia_Tubo/2]) sphere(Dia_Tubo/2,$fn=120);
    }
    
    translate([-Diametro/2-Distancia,0,0]) cylinder(Cubo+2,(Tornillo+Tolerancia)/2,(Tornillo+Tolerancia)/2,$fn=120,center=true);
    
    }
}


if (Mostrar=="Mordaza") {
rotate([0,-90,0]) {
Mordaza();
Encaje();
}
}

if (Mostrar=="Tirador") 
rotate([0,90,0]) {
Tirador();
}

if (Mostrar=="Palanca") 
rotate([90,90-Angulo,0]) {
Palanca();
}

if (Mostrar=="Pasador") 
Pasador();

if (Mostrar=="Todas") {
Mordaza();
Encaje();
Tirador();
translate([Diametro-Grosor/2,-(Diametro+Grosor*2)/2-Grosor/2,-Ancho/2]) Palanca();
translate([Diametro-Grosor/2+Desplazamiento,-(Diametro+Grosor*2)/2-Grosor/2,0]) Pasador();
}


